package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialInfoPublish;
import org.springblade.modules.martial.service.IMartialInfoPublishService;
import org.springframework.web.bind.annotation.*;

/**
 * 信息发布 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/infoPublish")
@Tag(name = "信息发布管理", description = "信息发布接口")
public class MartialInfoPublishController extends BladeController {

	private final IMartialInfoPublishService infoPublishService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialInfoPublish> detail(@RequestParam Long id) {
		MartialInfoPublish detail = infoPublishService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialInfoPublish>> list(MartialInfoPublish infoPublish, Query query) {
		IPage<MartialInfoPublish> pages = infoPublishService.page(Condition.getPage(query), Condition.getQueryWrapper(infoPublish));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialInfoPublish infoPublish) {
		return R.status(infoPublishService.saveOrUpdate(infoPublish));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(infoPublishService.removeByIds(Func.toLongList(ids)));
	}

}
